<?php

namespace App\Http\Controllers;

use App\Models\Administrador;
use Illuminate\Http\JsonResponse;
use Illuminate\Http\Request;

class AdministradorController extends Controller
{
    /**
     * Display a listing of the resource.
     */
    public function index(): JsonResponse
    {
        $items = Administrador::all();

        return response()->json([
            'success' => true,
            'data' => $items,
            'message' => 'Registros obtenidos correctamente',
        ], 200);
    }

    /**
     * Store a newly created resource in storage.
     */
    public function store(Request $request): JsonResponse
    {
        $payload = $request->only((new Administrador())->getFillable());
        $administrador = Administrador::create($payload);

        return response()->json([
            'success' => true,
            'data' => $administrador,
            'message' => 'Registro creado correctamente',
        ], 201);
    }

    /**
     * Display the specified resource.
     */
    public function show(Administrador $administrador): JsonResponse
    {
        return response()->json([
            'success' => true,
            'data' => $administrador,
            'message' => 'Registro obtenido correctamente',
        ], 200);
    }

    /**
     * Update the specified resource in storage.
     */
    public function update(Request $request, Administrador $administrador): JsonResponse
    {
        $payload = $request->only((new Administrador())->getFillable());
        $administrador->update($payload);

        return response()->json([
            'success' => true,
            'data' => $administrador,
            'message' => 'Registro actualizado correctamente',
        ], 200);
    }

    /**
     * Remove the specified resource from storage.
     */
    public function destroy(Administrador $administrador): JsonResponse
    {
        $administrador->delete();

        return response()->json([
            'success' => true,
            'message' => 'Registro eliminado correctamente',
        ], 200);
    }
}